<template lang="pug">
	#propiedades
		.documento
			h4 Documento
			.panel
				.titulo Previo
				.previo: img(:src="`${pagina.previo}`")
			.panel
				.titulo Tamaño
				.controles.grupo
					.control
						label Ancho
						input.input(
							v-model="documentoAncho", type="number", step="10",
							:readOnly="modo !== 'editor'"
						)
					.control
						label Alto
						input(v-model="documentoAlto", type="number", step="10",
							:readOnly="modo !== 'editor'")

			.panel(v-if="modo == 'editor'")
				.controles
					.control
						label Fondo
						input.input(
							v-model="documentoFondo", type="color"
						)

		.objeto(v-if="objeto")
			h4 Propiedades
			.panel(v-if="objeto.tag=='p' && ((modo == 'editor') || permisos.editable)" )
				.control.vertical
					label Texto
					textarea(:value="objeto.texto", rows="3",  @change="actualizarPropiedades({'texto': $event.target.value})")

			.panel(v-if="objeto.tag=='img' && ((modo == 'editor') || permisos.editable)" )
				.control.vertical
					label Ruta
					input(type="file", @change="fileImageChange")
					//- input(v-model="src", type="text")
					figure.previo
						img(:src="imagen")
						button(type="button", v-if="subir", @click="reemplazarImagen") Reemplazar


			.panel(v-if="(modo == 'editor') || permisos.movible")
				.titulo Posición
				.controles.grupo
					.control
						label X
						input.input(
							v-model="left", type="number"
						)
					.control
						label Y
						input(v-model="top", type="number")

			.panel(v-if="(modo == 'editor') || permisos.redimensionable")
				.titulo Tamaño
				.controles.grupo
					.control
						label Ancho
						input(v-model="width", type="number")
					.control
						label Alto
						input(v-model="height", type="number")


			.panel(v-if="modo == 'editor'")
				.titulo Colores
				.controles
					.control(v-if="objeto.tag=='p'" )
						label Color de Texto
						input(v-model="color", type="color")
					.control
						label Color de fondo
						input(v-model="backgroundColor", type="color")


			.panel(v-if="objeto.tag=='p' && modo == 'editor'" )
				.titulo Fuente
				.controles
					.control
						label Tipos de letra
						select(v-model="fontFamily")
							option(v-for="item in fuentes", :key="item") {{item}}

					.control
						label Tamaño de letra
						input(v-model="fontSize", type="number")
					.control
						label Interlineado
						input(v-model="lineHeight", type="number", step="0.1")

				.controles.grupo
					.control
						input#negrita(v-model="negrita", type="checkbox")
						label(for="negrita") Negrita
					.control
						input#italica(v-model="italica", type="checkbox")
						label(for="italica") Italica
					.control
						input#subrayado(v-model="subrayado", type="checkbox")
						label(for="subrayado") Subrayado

			.panel(v-if="objeto.tag=='p' && modo == 'editor'" )
				.titulo Atributos
				.controles
					.control
						label Relleno
						input(v-model="padding", type="number")

			.panel(v-if="objeto.tag=='img'" )
				.controles
					.control
						label Ajuste
						select(v-model="objectFit")
							option(value="cover" selected) Estirar
							option(value="contain") Ajustar
					.control
						label Alineacion
						select(v-model="objectPosition")
							option(value="top left" selected) Arriba Izquierda
							option(value="bottom left") Abajo Izquierda
							option(value="center center") Centro
							option(value="top right" selected) Arriba Derecha
							option(value="bottom right") Abajo Derecha
			.panel.permisos(v-if="modo == 'editor'")
				.titulo Control de usuario
				.controles
					.control
						input(type="checkbox", v-model="movible")
						label Se puede mover
					.control
						input(type="checkbox", v-model="redimensionable")
						label Se puede redimensional
					.control
						input(type="checkbox", v-model="editable")
						label Se puede editar

</template>


<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex'

import loadImage from "blueimp-load-image"

export default {

	data(){
		return {
			imagen: "",
			subir: false
		}
	},

	watch:{
		objeto(nuevo){
			// console.log("nuevo", nuevo)
			if(nuevo.tag == "img"){
				this.imagen = this.src
			}
		}
	},

	computed: {
		estilo:{
			get(){ return this.objeto.estilo }
		},
		atributos:{
			get(){ return this.objeto.atributos }
		},
		permisos:{
			get(){ return this.objeto.permisos }
		},
		top:{
			// get(){ return this.objeto ? parseInt(this.objeto.top) : 0 },
			get(){
				return parseInt(this.estilo.top)
			},
			set(valor){
				this.actualizarEstilo({top:`${valor}px`})
			}
		},
		left:{
			get(){ return parseInt(this.estilo.left) },
			set(valor){ this.actualizarEstilo({left:`${valor}px`}) }
		},
		width:{
			get(){ return parseInt(this.estilo.width) },
			set(valor){ this.actualizarEstilo({width:`${valor}px`}) }
		},
		height:{
			get(){ return parseInt(this.estilo.height) },
			set(valor){ this.actualizarEstilo({height:`${valor}px`}) }
		},
		padding:{
			get(){ return parseInt(this.estilo.padding) || 0 },
			set(valor){ this.actualizarEstilo({padding:`${valor}px`}) }
		},
		fontSize:{
			get(){ return parseInt(this.estilo.fontSize) || 12 },
			set(valor){ this.actualizarEstilo({fontSize:`${valor}px`}) }
		},
		lineHeight:{
			get(){ return parseFloat(this.estilo.lineHeight) || 1 },
			set(valor){ this.actualizarEstilo({lineHeight:valor}) }
		},
		color:{
			get(){ return this.estilo.color },
			set(valor){ this.actualizarEstilo({color:valor}) }
		},
		backgroundColor:{
			get(){ return this.estilo.backgroundColor },
			set(valor){ this.actualizarEstilo({backgroundColor:valor}) }
		},
		objectFit:{
			get(){ return this.estilo.objectFit || "cover" },
			set(valor){ this.actualizarEstilo({objectFit:valor}) }
		},
		objectPosition:{
			get(){ return this.estilo.objectPosition || "top left" },
			set(valor){ this.actualizarEstilo({objectPosition:valor}) }
		},
		src:{
			get(){ return this.atributos.src },
			set(valor){ this.actualizarAtributos({src:valor}) }
		},
		documentoAncho:{
			get(){ return parseInt(this.pagina.ancho) },
			set(valor){ this.actualizarPagina({ancho:parseInt(valor)}) }
		},
		documentoAlto:{
			get(){ return parseInt(this.pagina.alto) },
			set(valor){ this.actualizarPagina({alto:parseInt(valor)}) }
		},
		documentoFondo:{
			get(){ return this.pagina.fondo || "#ff0000" },
			set(valor){ this.actualizarPagina({fondo:valor}) }
		},

		movible:{
			get(){ return this.permisos.movible || false },
			set(valor){ this.actualizarPermisos({movible:valor}) }
		},

		redimensionable:{
			get(){ return this.permisos.redimensionable || false },
			set(valor){ this.actualizarPermisos({redimensionable:valor}) }
		},

		editable:{
			get(){ return this.permisos.editable || false},
			set(valor){ this.actualizarPermisos({editable:valor}) }
		},

		fontFamily:{
			get(){ return this.estilo.fontFamily || 'sans-serif'},
			set(valor){ this.actualizarEstilo({fontFamily:valor}) }
		},
		negrita:{
			get(){ return this.estilo.fontWeight == 700 },
			set(valor){ this.actualizarEstilo({fontWeight:valor?700:400}) }
		},
		italica:{
			get(){ return this.estilo.fontStyle == 'italic' },
			set(valor){ this.actualizarEstilo({fontStyle:valor?'italic':'normal'}) }
		},
		subrayado:{
			get(){ return this.estilo.textDecoration == 'underline' },
			set(valor){ this.actualizarEstilo({textDecoration:valor?'underline':'none'}) }
		},

		...mapState({
			fuentes: state => state.editor.fuentes,
			modo: state => state.editor.modo,
		}),

		...mapGetters({
			pagina: "contenido/actual",
			objeto: "contenido/activo",
			permisos: "contenido/permisos"
		}),

	},
	methods:{
		async fileImageChange(evt){
			const file = evt.target.files[0]
			// const reader = new FileReader();

			// reader.readAsDataURL(file);
			// reader.onload = () => {
			// 	// this.valor = reader.result
			// 	console.log(this.valor)
			// 	this.$axios.$post("/imagen", {
			// 		base64: reader.result,
			// 	})
			// 	.then(response => {
			// 		console.debug(response);

			// 		this.src = response.url;
			// 	})
			// 	.catch(function (error) {
			// 		console.log(error);
			// 	});

			// };
			// reader.onerror = (error) => {
			// 	console.log('Error: ', error);
			// };

			const {image} = await loadImage(file,{
				maxWidth: this.documentoAncho,
				maxHeight: this.documentoAlto,
				cover: true,
				canvas: true
			});

			const dataURL = image.toDataURL()
			this.imagen = dataURL
			this.subir = true

			// const {url} = await this.$axios.$post("/imagen", {
			// 	base64: dataURL,
			// })

			// this.src = url

		},

		async reemplazarImagen(evt){
			if(this.subir){
				const {url} = await this.$axios.$post("/imagen", {
					base64: this.imagen,
				})

				this.imagen = this.src = url
				this.subir = false

			}
		},
		obtenerCifra(texto){
			const regex =  /^(\d+(\.\d+)?)/
			var arr = regex.exec(texto)
			// console.log(arr)
			return arr ? arr[0] : 0
		},
		textoChange(evt){
			this.texto(evt.target.value)
		},
		actualizar(propiedad, valor){
			console.debug(arguments)
		},
		...mapMutations({
			// actualizarEstilo: "contenido/actualizarEstilo",
			// actualizarPropiedades: "contenido/actualizarPropiedades",
			// actualizarPermisos: "contenido/actualizarPermisos",
		}),
		...mapActions({
			actualizarEstilo: "editor/actualizarEstiloElemento",
			actualizarAtributos: "editor/actualizarAtributosElemento",
			actualizarPagina: "editor/actualizarPagina",
			actualizarPropiedades: "editor/actualizarPropiedades",
			actualizarPermisos: "editor/actualizarPermisos",
		})

	},
	mounted(){
		// console.debug(this.$config)
		// console.debug(this.$config)
		// console.debug(this)

	}
}
</script>



<style lang="stylus" scoped>
#propiedades
	background-color #333
	padding .5rem
	padding-top 0px
	max-width 320px
	h4
		margin-bottom .5rem
		margin-top .5rem
		font-weight bold
		color white



	*
		// outline 1px solid red


button
	padding .2em .5em
	width 100%
	border none
	// border 1px solid rgba(255,255,225,0.5)

label
	display: block
	font-size 13px

.panel
	border-bottom: 1px solid rgba(255,255,225,0.3)
	padding .5rem

.controles
	// @apply flex

	&.grupo
		display flex
		gap 1rem

.titulo
	margin-bottom .5rem
	font-weight bold
	color tint(#014492, 50%)
	font-size 13px

.control
	flex 1 1 auto
	margin-bottom .5rem
	display flex
	align-items center

	&.vertical
		flex-direction column
		align-items stretch


	&+.control
		// margin-left 1rem

	label
		// @apply flex-none
		flex 0 0 auto
		padding 0 .5em 0 0
		color white

	input[type="text"]
	input[type="url"]
	input[type="number"]
	select
		display block
		flex 0 1 auto
		width 100%
		// appearance none
		border 1px solid rgba(255,255,225,0.5)
		border-radius .2em
		padding .2em .5em
		font-size 12px
		// @apply p-1 shadow appearance-none border rounded

		&[readOnly]
			background-color silver
			user-select none

		.permisos &
			flex 0 1 auto

	input[type="file"]
		display block
		max-width 100%
		// outline 1px solid red
		overflow hidden

	input[type="color"]
		padding 0
		border-radius .2em

	button
		display block
		color white
		background-color #014492

</style>
